'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Dialog = require('material-ui/Dialog');

var _Dialog2 = _interopRequireDefault(_Dialog);

var _FlatButton = require('material-ui/FlatButton');

var _FlatButton2 = _interopRequireDefault(_FlatButton);

var _TextField = require('material-ui/TextField');

var _TextField2 = _interopRequireDefault(_TextField);

var _formatting = require('../formatting');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var LinkDialog = function (_React$Component) {
  _inherits(LinkDialog, _React$Component);

  function LinkDialog() {
    _classCallCheck(this, LinkDialog);

    var _this = _possibleConstructorReturn(this, (LinkDialog.__proto__ || Object.getPrototypeOf(LinkDialog)).call(this));

    _this.state = {
      url: ''
    };
    _this.onChange = _this.onChange.bind(_this);
    _this.insertLink = _this.insertLink.bind(_this);
    return _this;
  }

  _createClass(LinkDialog, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(_ref) {
      var tokens = _ref.tokens,
          cm = _ref.cm;

      if (tokens[1] && tokens[1] === 'url') {
        this.setState({ url: (0, _formatting.getUrl)(cm.codeMirror) });
      }
    }
  }, {
    key: 'onChange',
    value: function onChange(e) {
      this.setState({
        url: e.target.value
      });
    }
  }, {
    key: 'insertLink',
    value: function insertLink() {
      var url = this.state.url;
      var _props = this.props,
          cm = _props.cm,
          tokens = _props.tokens,
          isImageDialog = _props.isImageDialog;


      this.setState({ url: '' });
      this.context.toggleDialog()();

      return (0, _formatting.isUrl)(tokens) ? (0, _formatting.updateUrl)(cm, url) : (0, _formatting.setUrl)(cm, url, isImageDialog);
    }
  }, {
    key: 'render',
    value: function render() {
      var isDialogOpen = this.props.isDialogOpen;
      var toggleDialog = this.context.toggleDialog;

      return _react2.default.createElement(
        _Dialog2.default,
        {
          title: 'Insert hyperlink',
          actions: [_react2.default.createElement(_FlatButton2.default, {
            label: 'Cancel',
            primary: true,
            onTouchTap: toggleDialog()
          }), _react2.default.createElement(_FlatButton2.default, {
            label: 'Ok',
            primary: true,
            keyboardFocused: true,
            disabled: this.state.url === '',
            onTouchTap: this.insertLink
          })],
          modal: false,
          open: isDialogOpen,
          onRequestClose: toggleDialog()
        },
        _react2.default.createElement(_TextField2.default, {
          id: 'url',
          onChange: this.onChange,
          floatingLabelText: 'Url',
          value: this.state.url,
          style: {
            width: '100%'
          }
        })
      );
    }
  }]);

  return LinkDialog;
}(_react2.default.Component);

LinkDialog.propTypes = {
  isDialogOpen: _react.PropTypes.bool.isRequired,
  cm: _react.PropTypes.object, //eslint-disable-line
  isImageDialog: _react.PropTypes.bool,
  tokens: _react.PropTypes.arrayOf(_react.PropTypes.string)
};
LinkDialog.contextTypes = {
  toggleDialog: _react.PropTypes.func
};
exports.default = LinkDialog;