'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactCodemirror = require('react-codemirror');

var _reactCodemirror2 = _interopRequireDefault(_reactCodemirror);

var _LinkDialog = require('./LinkDialog');

var _LinkDialog2 = _interopRequireDefault(_LinkDialog);

var _ToolbarPanel = require('./ToolbarPanel');

var _ToolbarPanel2 = _interopRequireDefault(_ToolbarPanel);

var _markdown = require('codemirror/mode/markdown/markdown');

var _markdown2 = _interopRequireDefault(_markdown);

var _formatting = require('./formatting');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } // eslint-disable-line


var MarkdownEditor = function (_React$Component) {
  _inherits(MarkdownEditor, _React$Component);

  function MarkdownEditor() {
    _classCallCheck(this, MarkdownEditor);

    var _this = _possibleConstructorReturn(this, (MarkdownEditor.__proto__ || Object.getPrototypeOf(MarkdownEditor)).call(this));

    _this.state = {
      tokens: [],
      code: '',
      isDialogOpen: false,
      isImageDialog: false
    };
    _this.updateCode = _this.updateCode.bind(_this);
    _this.toggleDialog = _this.toggleDialog.bind(_this);
    return _this;
  }

  _createClass(MarkdownEditor, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        toggleDialog: this.toggleDialog
      };
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      /* need to trigger rerender since tooblbar is rendered before
       Codemirror textarea and we can't get it's ref at first render */
      this.setState({
        cm: this.cm,
        code: this.props.code,
        title: this.props.title
      }); //eslint-disable-line
      this.cm.codeMirror.on('cursorActivity', this.updateTokens.bind(this));
    }
  }, {
    key: 'toggleDialog',
    value: function toggleDialog(isImageDialog) {
      var _this2 = this;

      return function () {
        _this2.setState({ isDialogOpen: !_this2.state.isDialogOpen, isImageDialog: isImageDialog });
      };
    }
  }, {
    key: 'updateTokens',
    value: function updateTokens() {
      var tokens = (0, _formatting.getCurrentFormat)(this.cm);
      this.setState({ tokens: tokens });
    }
  }, {
    key: 'updateCode',
    value: function updateCode(newCode) {
      this.setState({
        code: newCode
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var options = {
        lineNumbers: true,
        mode: 'markdown'
      };

      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(_LinkDialog2.default, {
          isDialogOpen: this.state.isDialogOpen,
          isImageDialog: this.state.isImageDialog,
          toggleDialog: this.toggleDialog,
          tokens: this.state.tokens,
          cm: this.state.cm
        }),
        _react2.default.createElement(_ToolbarPanel2.default, {
          cm: this.state.cm,
          tokens: this.state.tokens,
          title: this.state.title
        }),
        _react2.default.createElement(_reactCodemirror2.default, {
          ref: function ref(_ref) {
            _this3.cm = _ref;
          },
          value: this.state.code,
          onChange: this.updateCode,
          options: options
        })
      );
    }
  }]);

  return MarkdownEditor;
}(_react2.default.Component);

MarkdownEditor.childContextTypes = {
  toggleDialog: _react.PropTypes.func
};
MarkdownEditor.propTypes = {
  code: _react.PropTypes.string,
  title: _react.PropTypes.string
};
exports.default = MarkdownEditor;