'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _formatBold = require('material-ui/svg-icons/editor/format-bold');

var _formatBold2 = _interopRequireDefault(_formatBold);

var _formatItalic = require('material-ui/svg-icons/editor/format-italic');

var _formatItalic2 = _interopRequireDefault(_formatItalic);

var _formatSize = require('material-ui/svg-icons/editor/format-size');

var _formatSize2 = _interopRequireDefault(_formatSize);

var _formatListBulleted = require('material-ui/svg-icons/editor/format-list-bulleted');

var _formatListBulleted2 = _interopRequireDefault(_formatListBulleted);

var _formatListNumbered = require('material-ui/svg-icons/editor/format-list-numbered');

var _formatListNumbered2 = _interopRequireDefault(_formatListNumbered);

var _formatQuote = require('material-ui/svg-icons/editor/format-quote');

var _formatQuote2 = _interopRequireDefault(_formatQuote);

var _code = require('material-ui/svg-icons/action/code');

var _code2 = _interopRequireDefault(_code);

var _image = require('material-ui/svg-icons/image/image');

var _image2 = _interopRequireDefault(_image);

var _insertLink = require('material-ui/svg-icons/editor/insert-link');

var _insertLink2 = _interopRequireDefault(_insertLink);

var _expandMore = require('material-ui/svg-icons/navigation/expand-more');

var _expandMore2 = _interopRequireDefault(_expandMore);

var _colors = require('material-ui/styles/colors');

var _formatting = require('../formatting');

var _FlexWrapper = require('./FlexWrapper');

var _FlexWrapper2 = _interopRequireDefault(_FlexWrapper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getSchema = function getSchema(cm, tokens) {
  var getUrlStyle = (0, _formatting.getUrlStyleIfActive)(cm);
  var getActiveStyle = (0, _formatting.getStyleIfActive)(tokens);
  var formatBold = (0, _formatting.setBold)(cm);
  var cancelBold = (0, _formatting.removeBold)(cm);
  var formatItalic = (0, _formatting.setItalic)(cm);
  var cancelItalic = (0, _formatting.removeItalic)(cm);
  var formatUl = (0, _formatting.setUl)(cm);
  var cancelUl = (0, _formatting.removeUl)(cm);
  var formatOl = (0, _formatting.setOl)(cm);
  var cancelOl = (0, _formatting.removeOl)(cm);
  var formatCode = (0, _formatting.setCode)(cm);
  var cancelCode = (0, _formatting.removeCode)(cm);
  var formatQuote = (0, _formatting.setQuote)(cm);
  var cancelQuote = (0, _formatting.removeQuote)(cm);
  var handleH1 = (0, _formatting.isActiveToken)('header-1', tokens, 1) ? (0, _formatting.removeH1)(cm) : (0, _formatting.setH1)(cm);
  var handleH2 = (0, _formatting.isActiveToken)('header-2', tokens, 1) ? (0, _formatting.removeH2)(cm) : (0, _formatting.setH2)(cm);
  var handleH3 = (0, _formatting.isActiveToken)('header-3', tokens, 1) ? (0, _formatting.removeH3)(cm) : (0, _formatting.setH3)(cm);

  return [[{
    style: _extends({
      marginLeft: 24,
      height: 'auto',
      padding: 6
    }, getActiveStyle('header')),
    isDropDown: true,
    onItemTouchTap: (0, _formatting.handleHeading)([handleH1, handleH2, handleH3]),
    options: [{
      primaryText: 'Heading 1',
      style: { fontSize: 12 }
    }, {
      primaryText: 'Heading 2',
      style: { fontSize: 14 }
    }, {
      primaryText: 'Heading 3',
      style: { fontSize: 16 }
    }],
    icon: _react2.default.createElement(
      _FlexWrapper2.default,
      null,
      _react2.default.createElement(_formatSize2.default, { color: _colors.lightBlack }),
      _react2.default.createElement(_expandMore2.default, null)
    )
  }, {
    style: _extends({}, getActiveStyle('strong')),
    icon: _react2.default.createElement(_formatBold2.default, { color: _colors.lightBlack }),
    onClick: (0, _formatting.isActiveToken)('strong', tokens) ? cancelBold : formatBold
  }, {
    style: getActiveStyle('em'),
    icon: _react2.default.createElement(_formatItalic2.default, { color: _colors.lightBlack }),
    onClick: (0, _formatting.isActiveToken)('em', tokens) ? cancelItalic : formatItalic
  }], [{
    style: _extends({ marginLeft: 24 }, getActiveStyle('ul')),
    icon: _react2.default.createElement(_formatListBulleted2.default, { color: _colors.lightBlack }),
    onClick: (0, _formatting.isActiveToken)('ul', tokens) ? cancelUl : formatUl
  }, {
    style: getActiveStyle('ol'),
    icon: _react2.default.createElement(_formatListNumbered2.default, { color: _colors.lightBlack }),
    onClick: (0, _formatting.isActiveToken)('ol', tokens) ? cancelOl : formatOl
  }], [{
    style: _extends({ marginLeft: 24 }, getActiveStyle('comment')),
    icon: _react2.default.createElement(_code2.default, { color: _colors.lightBlack }),
    onClick: (0, _formatting.isActiveToken)('comment', tokens) ? cancelCode : formatCode
  }, {
    style: _extends({}, getActiveStyle('quote')),
    icon: _react2.default.createElement(_formatQuote2.default, { color: _colors.lightBlack }),
    onClick: (0, _formatting.isActiveToken)('quote', tokens) ? cancelQuote : formatQuote
  }], [{
    style: _extends({
      marginLeft: 24
    }, (0, _formatting.isActiveToken)('url', tokens, 1) ? getUrlStyle('link') : {}),
    icon: _react2.default.createElement(_insertLink2.default, { color: _colors.lightBlack }),
    openDialog: true
  }, {
    style: _extends({}, (0, _formatting.isActiveToken)('url', tokens, 1) ? getUrlStyle('image') : {}),
    icon: _react2.default.createElement(_image2.default, { color: _colors.lightBlack }),
    openDialog: true,
    isImageDialog: true
  }]];
};

exports.default = getSchema;